#include <iostream>
using std::cout;
#include "BasicTypes.h"
#include "BasicTypesLists.h"
#include "CustomTypes.h"
#include "SocketStream.h"
#include "SocketException.h"

int main(void)
{
    cout<<"------------ mainBasicTypes2";
	cout<<"\n";

	SocketStream ss;
	try
	{	
		cout<< "------------ Trying to connect on 127.0.0.1 " <<" ...";
		ss.connect("127.0.0.1", 9090);
		cout<<" OK\n";

		map<int,Object*> mapToSend;	

		BasicTypes basic;
		basic.setAByte(1);
		basic.setAShort(1);
		basic.setAInt(1);
		basic.setALong(1);
		basic.setADouble(1);
		basic.setABoolean(true);
		basic.setAString("coucou");
		mapToSend[0] = &basic;
		cout<<"------------ before encodeData( )\n";
		CustomTypes::encodeData(mapToSend, ss);
		cout<<"------------ after encodeData( )\n";

		ss.close();
	}
	catch(SocketException& e)
	{
		cout<<e.description();
	}
	
	
	

}

