#include <iostream>
using std::cout;
/*
#include "BasicTypes.h"
#include "BasicTypesLists.h"
*/
#include "CustomTypes.h"
#include "SocketStream.h"
#include "SocketException.h"
#include <vector>

int main(void)
{
    cout<<"------------ mainObjectTypes2";
	cout<<"\n";

	SocketStream ss;
	try
	{
		cout<< "------------ Trying to connect on 127.0.0.1 " <<" ...";
		ss.connect("127.0.0.1", 9090);
		cout<<" OK\n";
	
		map<int,Object*> mapToSend;	

		ObjectA objectA;
		ObjectC objectC1;

		ObjectB objectB;
		ObjectC objectC2;
		ObjectC objectC3;

		std::vector<ObjectC> vObjectCforB;

		objectC1.setAString("un");
		objectC2.setAString("deux");
		objectC3.setAString("trois");

		objectA.setObjectC(objectC1);

		vObjectCforB.push_back(objectC2);
		vObjectCforB.push_back(objectC3);

		objectB.setObjectC(vObjectCforB);		

		mapToSend[0] = &objectA;
		mapToSend[1] = &objectB;
		cout<<"------------ before encodeData( )\n";
		CustomTypes::encodeData(mapToSend, ss);
		cout<<"------------ after encodeData( )\n";

		ss.close();
	}
	catch(SocketException& e)
	{
		cout<<e.description();
	}

}
