#include <iostream>
#include "BasicTypes.h"
#include "CustomTypes.h"
#include "SocketStream.h"
#include "SocketException.h"
#include <map>

int main(void)
{
	SocketStream ss;
	try
	{	
		// Connection to localhost		
		ss.connect("127.0.0.1", 9090);
 		// Creation of an instance of BasicType
		BasicTypes basic;
		basic.setAByte((char)1);
		basic.setAShort(1);
		basic.setABoolean(true);
		basic.setAInt(1);
		basic.setALong(1);
		basic.setADouble(1);
		basic.setAFloat(1);
		basic.setAString("Hello world !");
		// Insertion in map
		map<int,Object*> mapToSend;
		mapToSend[0] = &basic;
		// Encoding of the map
		CustomTypes::encodeData(mapToSend, ss);
		// Closing socket attached to SocketStream ss
		ss.close();
	}
	catch(SocketException& e)
	{
		std::cout<<e.description();
	}

}

