#include <iostream>
using std::cout;
#include "BasicTypes.h"
#include "BasicTypesLists.h"
#include "CustomTypes.h"
#include "SocketStream.h"
#include "SocketException.h"
#include <vector>

int main(void)
{
    cout<<"------------ mainBasicTypesList2";
	cout<<"\n";

	SocketStream ss;
	try
	{
		cout<< "------------ Trying to connect on 127.0.0.1 " <<" ...";
		ss.connect("127.0.0.1", 9090);
		cout<<" OK\n";
	
		map<int,Object*> mapToSend;

		 std::vector<char> aByteList;
		 aByteList.push_back(1);
		 aByteList.push_back(2);
		 aByteList.push_back(3);

		 std::vector<short> aShortList;
		 aShortList.push_back(1);
		 aShortList.push_back(2);
		 aShortList.push_back(3);

		 std::vector<int> aIntList;
		 aIntList.push_back(1);
		 aIntList.push_back(2);
		 aIntList.push_back(3);

		 std::vector<long long> aLongList;
		 aLongList.push_back(1);
		 aLongList.push_back(2);
		 aLongList.push_back(3);

		 std::vector<float> aFloatList;
		 aFloatList.push_back(1);
		 aFloatList.push_back(2);
		 aFloatList.push_back(3);

		 std::vector<double> aDoubleList;
		 aDoubleList.push_back(1);
		 aDoubleList.push_back(2);
		 aDoubleList.push_back(3);

		 std::vector<bool> aBooleanList;
		 aBooleanList.push_back(true);
		 aBooleanList.push_back(false);
		 aBooleanList.push_back(true);

		 std::vector<std::string> aStringList;
		 aStringList.push_back("hello");
		 aStringList.push_back("world!");

		BasicTypesLists basiclists;
		basiclists.setAByteList(aByteList);
		basiclists.setAShortList(aShortList);
		basiclists.setAIntList(aIntList);
		basiclists.setALongList(aLongList);
		basiclists.setADoubleList(aDoubleList);
		basiclists.setABooleanList(aBooleanList);
		basiclists.setAStringList(aStringList);

		mapToSend[0] = &basiclists;
		cout<<"------------ before encodeData( )\n";
		CustomTypes::encodeData(mapToSend, ss);
		cout<<"------------ after encodeData( )\n";

		ss.close();
	}
	catch(SocketException& e)
	{
		cout<<e.description();
	}

}
