package tests;

import java.io.*;
import java.util.*;

public class TempFileManager
{
    static private Date date = new Date();

    static private String makeTempFileName()
    {
        return String.valueOf(date.getTime());
    }

    static public File makeTempFile () throws IOException
    {
        File file = File.createTempFile (makeTempFileName(), "tmp");
        return file;
    }
    
    static public void removeTempFile (File file)
    {
        file.delete();
    }
}
